from nevow import rend
from nevow import loaders
from nevow import tags as T

from formless import annotate
from formless import webform
from formless import configurable

class MyConfigurable(configurable.Configurable):

    def getBindingNames(self, ctx):
        return ['form']

    def bind_form(self, ctx):
        elements = [
            annotate.Argument('astring', annotate.String()),
            annotate.Argument('aninteger', annotate.Integer())
            ]
        return annotate.MethodBinding(
            'action', annotate.Method(arguments=elements))

    def action(self, **kwargs):
        print "ACTION:", kwargs


class MyPage(rend.Page):
    docFactory = loaders.xmlfile('main.xml')

    def render_content(self, ctx, data):
        return ctx.tag.clear()[MyForm()]

    def data_title(self, ctx, data):
        return "Does not work"

    def configurable_form(self, ctx):
        if not hasattr(self, '_configurable'):
            self._configurable = MyConfigurable(None)
        return self._configurable


class MyForm(rend.Fragment):
    docFactory = loaders.xmlfile('form.xml')

    def render_form(self, ctx, data):
        return webform.renderForms('form')[ctx.tag]

    def data_xxx(self, ctx, data):
        print "DATA:", data
        return "If you read this, it is working!"

    
from nevow import appserver
from twisted.application import service
from twisted.application import internet

application = service.Application('doesnotwork')
site = appserver.NevowSite(MyPage())
internet.TCPServer(8080, site).setServiceParent(application)
